local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local DT = E:GetModule('DataTexts')

local format = string.format
local join = string.join

local lastPanel
local displayString = ""
local tooltipString = ""

local function OnEvent(self, event, ...)
	local prof1, prof2, archy, fishing, cooking, firstAid = GetProfessions()
	
	if profdt_db.prof == "prof1" then
		
		if prof1 ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(prof1)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	elseif profdt_db.prof == "prof2" then
	
		if prof2 ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(prof2)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	elseif profdt_db.prof == "archy" then
	
		if archy ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(archy)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	elseif profdt_db.prof == "fishing" then
	
		if fishing ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(fishing)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	elseif profdt_db.prof == "cooking" then
	
		if cooking ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(cooking)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	elseif profdt_db.prof == "firstaid" then
	
		if firstAid ~= nil then
			local name, _, rank, maxRank, _, _, _, _ = GetProfessionInfo(firstAid)
			self.text:SetFormattedText(displayString, name, rank, maxRank)
		else
			self.text:SetText("No Profession")
		end
	
	end
end

local function Click(self, button)
	local prof1, prof2, archy, fishing, cooking, firstAid = GetProfessions()
	if button == "LeftButton" then
		if IsShiftKeyDown() and archy == nil then return
		elseif not IsShiftKeyDown() and prof1 == nil then return end
		local name, _, _, _, _, _, _, _ = GetProfessionInfo(IsShiftKeyDown() and archy or prof1)
		CastSpellByName(name)
	elseif button == "RightButton" then
		if IsShiftKeyDown() and cooking == nil then return
		elseif not IsShiftKeyDown() and prof2 == nil then return end
		local name, _, _, _, _, _, _, _ = GetProfessionInfo(IsShiftKeyDown() and cooking or prof2)
		CastSpellByName(name)
	end
end

local function OnEnter(self)
	DT:SetupTooltip(self)
	
	local prof1, prof2, archy, fishing, cooking, firstAid = GetProfessions()
	local professions = {}
	
	if prof1 ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(prof1)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if prof2 ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(prof2)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if archy ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(archy)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if fishing ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(fishing)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if cooking ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(cooking)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if firstAid ~= nil then
		local name, texture, rank, maxRank, _, _, _, _ = GetProfessionInfo(firstAid)
		professions[#professions + 1] = {
			name	= name,
			texture	= ("|T%s:12:12:1:0|t"):format(texture),
			rank	= rank,
			maxRank	= maxRank
		}
	end
	
	if #professions == 0 then return end	
	sort(professions, function(a, b) return a["name"] < b["name"] end)
	
	for i = 1, #professions do
		GameTooltip:AddDoubleLine(join("", professions[i].texture, "  ", professions[i].name), tooltipString:format(professions[i].rank, professions[i].maxRank), 1, 1, 1, 1, 1, 1)
	end
	
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine("Left Click:", "Open First Profession", 0.7, 0.7, 1, 1, 1, 1)
	GameTooltip:AddDoubleLine("Right Click:", "Open Second Profession", 0.7, 0.7, 1.0, 1, 1, 1)
	GameTooltip:AddDoubleLine("Shift + Left Click:", "Open Archaeology", 0.7, 0.7, 1.0, 1, 1, 1)
	GameTooltip:AddDoubleLine("Shift + Right Click:", "Open Cooking", 0.7, 0.7, 1.0, 1, 1, 1)
	
	GameTooltip:Show()
end

local function ValueColorUpdate(hex, r, g, b)
	displayString = join("", "|cffffffff%s:|r ", hex, "%d|r/", hex, "%d|r")
	tooltipString = join("" , hex, "%d|r|cffffffff/|r", hex, "%d|r")
	if lastPanel ~= nil then OnEvent(lastPanel) end
end
E["valueColorUpdateFuncs"][ValueColorUpdate] = true

profdt_db = profdt_db or {
	["prof"]	= "prof1"
}

E.Options.args.datatexts.args.prof = {
	type = "select",
	order = 4,
	name = "Professions",
	desc = "Select which profession to display.",
	get = function(info) return profdt_db[info[#info]] end,
	set = function(info, value) profdt_db[info[#info]] = value; DT:LoadDataTexts() end,
	values = {
		["prof1"]		= "Profession 1",
		["prof2"]		= "Profession 2",
		["archy"]		= "Archaeology",
		["fishing"]		= "Fishing",
		["cooking"]		= "Cooking",
		["firstaid"]	= "First Aid",
	}
}

DT:RegisterDatatext("Professions", {"PLAYER_ENTERING_WORLD", "CHAT_MSG_SKILL", "TRADE_SKILL_UPDATE"}, OnEvent, nil, Click, OnEnter)